
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import java.util.Random;

public class Bestellung implements Comparable<Bestellung> {
	static int nr = 0;
	static final int VERSION = 1;
	private String artikel = "";
	private double preis = 0.0;
	private String bez = "";

	public Bestellung(Random generator) {
		this.artikel = "Artikel_" + Basic.int2String(++nr, 5);
		int n = (int) (1 + generator.nextDouble() * 5);
		this.preis = generator.nextDouble();
		for (int i = 0; i < n; i++) {
			preis *= 10.0;
		}
		bez = "";
		switch (generator.nextInt(12)) {
		case 0:
			bez = "EDV;Elektronik";
			break;
		case 1:
			bez = "Telefon;Handy";
			break;
		case 2:
			bez = "Kleidung;Elektronik";
			break;
		case 3:
			bez = "Kleidung";
			break;
		case 4:
			bez = "EDV;Handy";
			break;
		case 5:
			bez = "TV;LCD;Ernhrung";
			break;
		case 6:
			bez = "Schuhe;Kleidung";
			break;
		case 7:
			bez = "Mbel";
			break;
		case 8:
			bez = "Mbel;Elektronik";
			break;
		case 9:
			bez = "Blumen;Bcher";
			break;
		case 10:
			bez = "Bcher";
			break;
		case 11:
			bez = "Blumen;Kleidung";
			break;
		}
	}

	public Bestellung() {
		this.artikel = "";
		this.preis = 0.0;
	}

	public Bestellung(String artikel, double preis) {
		this.artikel = artikel;
		this.preis = preis;
		bez = "";
	}

	/**
	 * Schreiben der Attribute 1. Version (Konstante oben) 2. artikel 3. preis
	 * 4. bez write Strings mit writeUTF
	 * 
	 * @param dout
	 * @throws IOException
	 */
	public void write2File(DataOutputStream dout) throws IOException {
		// hier fehlt Code
	}

	/**
	 * 
	 * Lesen der Attribute 1. Version 2. artikel 3. preis 4. bez read Strings
	 * mit readUTF Abfragen der Version, Kontrolle
	 * 
	 * @param din
	 * @throws IOException
	 */
	public void readfromFile(DataInputStream din) throws IOException {
		// hier fehlt Code
	}

	@Override
	public int compareTo(Bestellung best) {
		int ret = artikel.compareTo(best.artikel);
		if (ret == 0)
			ret = Double.compare(preis, best.preis);
		return ret;
	}

	public String getArtikel() {
		return artikel;
	} // getArtikel

	public void setArtikel(String value) {
		artikel = value;
	} // setArtikel

	public double getPreis() {
		return preis;
	} // getpreis

	public void setPreis(double value) {
		preis = value;
	} // setpreis

	public String getBezeichungen() {
		return bez;
	} // getBezeichungen

	public void setBezeichungen(String value) {
		bez = value;
	} // setBezeichungen

} // Bestellung
