import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTextArea;

public class Middleware {

	/**
	 * Liefert den Dateinamen fuer die i-te Bestellung
	 * 
	 * @param nr
	 * @return Dateinamen der Bestellung
	 */
	private String getBstFilename(int nr) {
		return "Aufgabe05_" + Basic.int2String(nr, 3) + ".bst";
	}

	/**
	 * Liefert den Dateinamen fuer die i-te DataMining
	 * 
	 * @param nr
	 * @return Dateinamen der DataMining
	 */
	private String getDataMiningFilename(int nr) {
		return "Aufgabe05_" + Basic.int2String(nr, 3) + ".dm";
	}

	/**
	 * Liefert den Dateinamen fuer die zusammengefassten Bestellung
	 * 
	 * @param nr
	 * @return Merge Dateinamen
	 */
	private String getMergeFilename() {
		return "Aufgabe05.merge";
	}

	/**
	 * 
	 * @param editor
	 * @param maxItems
	 * @param anzThreads
	 */
	/**
	 * Erzeugt die i.te Datei mittels getBstFilename pro Datei: Schreibt als
	 * erstes die Anzahl der Bestellungen Benutzt eine Instanz der Klasse Random
	 * (Konstruktor Bestellung) Schreibt danach die einzelnen Bestellungen
	 * mittels EINER Methode Schliesst die Datei
	 */
	public void Create1_Files(JTextArea editor, int maxItems, int anzThreads) {
		long t1, t2;
		/*
		try {
			t1 = System.currentTimeMillis();
			FileOutputStream fout = null;
			BufferedOutputStream bout = null;
			DataOutputStream dout = null;
			Bestellung best;
			Random generator = new Random();
			// ab hier fehlt Code

			
			t2 = System.currentTimeMillis();
			Basic.MessageBox("Habe fertig", "Die Dateien wurde erzeugt");
			editor.append("\nCreate1 Buffered Zeit: " + (t2 - t1) + "  ms");
		} catch (IOException e) {
			System.err.println("IOException: " + e);
		}
		*/
	}

	/**
	 * 
	 * @param editor
	 * @param maxItems
	 * @param anzThreads
	 */
	/**
	 * Erzeugt die Dateien mittels Threads 1. Thread Array erzeugen 2.
	 * CreateThread Instanzen erstellen 3. starten 4. zusammenfassen j.in 5.
	 * Meldung ausgeben
	 */
	public void CreateN_Files(JTextArea editor, int maxItems, int anzThreads) {
		long t1, t2;
		t1 = System.currentTimeMillis();
		CreateThread[] ct;
		// ab hier fehlt Code

		
		
		t2 = System.currentTimeMillis(); // .nanoTime();
		Basic.MessageBox("Habe fertig", "Die Dateien wurde erzeugt");
		editor.append("\nCreateN Thread: Buffered Zeit: " + (t2 - t1) + "  ms");
	}

	/**
	 * 
	 * @param editor
	 * @param anzThreads
	 * @param searchBez
	 */
	/**
	 * Das DataMining wird mittels Schleife durchgefuehrt ArrayList erstellen
	 * pro Durchlauf: lesen der i-ten Datei (getBstFilename) pro Bestellung wird
	 * mittels in.....f der Suchstring gesucht wenn vorhanden, in die Liste
	 * eintragen Schliesst die Datei Anzahl erhoehen
	 * 
	 * Schreiben der Daten der Liste in die i.te dm-datei
	 * (getDataMiningFilename) Schliesst die Datei Anzahl in den Editor ausgeben
	 * (append) Meldung ausgeben
	 */
	public void DataMining1(JTextArea editor, int anzThreads, String searchBez) {
		long t1, t2;
		int anz = 0;
		ArrayList liste = null;
		/*
		try {
			t1 = System.currentTimeMillis();
			FileInputStream fin = null;
			DataInputStream din = null;
			BufferedInputStream bin = null;

			FileOutputStream fout = null;
			DataOutputStream dout = null;
			BufferedOutputStream bout = null;
			Bestellung best;
			// ab hier fehlt Code
			

			t2 = System.currentTimeMillis();
			Basic.MessageBox("Habe fertig",
					"Data Mining: Die Dateien wurde verarbeitet");
			editor.append("\nData Mining1 Zeit: " + (t2 - t1) + "  ms");
			editor.append("\n  Anzahl der Datenstze: " + anz);
		} catch (IOException e) {
			System.err.println("IOException: " + e);
		}
*/
	}

	/**
	 * 
	 * @param editor
	 * @param anzThreads
	 * @param searchBez
	 */
	/**
	 * Das DataMining wird mittels Threads durchgefuehrt 1. Thread Array
	 * erzeugen 2. DataMiningThread Instanzen erstellen 3. starten 4.
	 * zusammenfassen j.in 5. Anzahl in den Editor ausgeben (append) 6. Meldung
	 * ausgeben
	 */
	public void DataMiningN(JTextArea editor, int anzThreads, String searchBez) {
		long t1, t2;
		int anz=0;
		t1 = System.currentTimeMillis();
		DataMiningThread[] st=null;
		// ab hier fehlt Code

		
		t2 = System.currentTimeMillis(); // .nanoTime();
		anz = 0;
		// hier fehlt weiterer Code
		Basic.MessageBox("Habe fertig",
				"Data Mining: Die Dateien wurde verarbeitet");
		editor.append("\nThread Data Mining Buffered Zeit: " + (t2 - t1)
				+ "  ms");
		editor.append("\n  Anzahl der Datenstze: " + anz);
	}

	/**
	 * 
	 * @param editor
	 * @param anzThreads
	 */
	/**
	 * Das Merge wird mittels Schleife durchgefuehrt ArrayList erstellen pro
	 * Durchlauf: lesen der i-ten Datei (getDataMiningFilename) Schliesst die
	 * Datei
	 * 
	 * Sortieren Schreiben der Daten der Liste in die Merge-datei
	 * (getMergeFilename) Schliesst die Datei Anzahl in den Editor ausgeben
	 * (append) Meldung ausgeben
	 */
	public void Merge_Files(JTextArea editor, int anzThreads) {
		long t1, t2;
		ArrayList liste = null;
		/*
		try {
			t1 = System.currentTimeMillis();
			FileInputStream fin = null;
			DataInputStream din = null;
			BufferedInputStream bin = null;

			FileOutputStream fout = null;
			DataOutputStream dout = null;
			BufferedOutputStream bout = null;
			Bestellung best;
			// ab hier fehlt Code
			
			Basic.MessageBox("Habe fertig",
					"Merge: Die Dateien wurden zusammengefasst");
			editor.append("\nMerge Zeit: " + (t2 - t1) + "  ms");
			editor.append("\n  Anzahl der Datenstze: " + liste.size());
		} catch (IOException e) {
			System.err.println("IOException: " + e);
		}
		*/

	}

}
